#include <bits/stdc++.h>

using namespace std;

int main()
{
    bool f=true;
    int t,n,k, ans;
    cin >> t >> n >> k;
    vector<int> a(n);
    for (int i=0; i<n; i++)
    {
        cin >> a[i];
        if(i>0 && a[i-1]!=a[i])
            f=false;
    }
    if(f)
    {
        if(a[0]>=0)
        {
            if(n>a[0])
            {
                ans=a[0]+1-((n-a[0]+1)%2);
            }
            else
                ans=n;
        }
        else
        {
            if(n>abs(a[0]))
            {
                ans=a[0]+1-((n-a[0]+1)%2);
            }
            else
                ans=-n;
        }
        if(k!=ans)
            cout << "NE";
        else
        {
            cout << "DA";
            if(t);
                for (int i=1; i<=n; i++)
                    cout << a[0] << " ";
        }
    }
    else if(n<=8)
    {

    }
    else
        cout << "!";
}